Subject: [PATCH 00/10] drivers: PL011: add ARM SBSA Generic UART support

From: [email-masked] (Andre Przywara)
Date: Tue, 20 Jan 2015 13:55:01 +0000

Hi Graeme,

On 20/01/15 13:08, Graeme Gregory wrote:
> On Fri, Jan 16, 2015 at 05:22:56PM +0000, Andre Przywara wrote:
>> The ARM Server Base System Architecture[1] document describes a
>> generic UART which is a subset of the PL011 UART.
>> It lacks DMA support, baud rate control and modem status line
>> control, among other things.
>> The idea is to move the UART initialization and setup into the
>> firmware (which does this job today already) and let the kernel just
>> use the UART for sending and receiving characters.
>>
>> This patchset integrates support for this UART subset into the
>> existing PL011 driver - basically by refactoring some
>> functions and providing a new uart_ops structure for it. It also has
>> a separate probe function to be not dependent on AMBA/PrimeCell.
>> It provides a device tree binding, but can easily be adapted to other
>> device configuration systems.
>> Beside the obvious effect of code sharing reusing most of the PL011
>> code has the advantage of not introducing another serial device
>> prefix, so it can go with ttyAMA, which seems to be pretty common.
>>
>> This series relies on Dave's recent PL011 fix[2], which gets rid of
>> the loopback trick to get the UART going. There is a repo at [3]
>> (branch sbsa-uart/v1), which has this patch already integrated.
>>
>> Patch 1/10 contains a bug fix which applies to the PL011 part also,
>> it should be considered regardless of the rest of the series.
>> Patch 2-7 refactor some PL011 functions by splitting them up into
>> smaller pieces, so that most of the code can be reused later by the
>> SBSA part.
>> Patch 8 and 9 introduce two new properties for the vendor structure,
>> this is for SBSA functionality which cannot be controlled by
>> separate uart_ops members only.
>> Patch 10 then finally drops in the SBSA specific code, by providing
>> a new uart_ops, vendor struct and probe function for it. Also the new
>> device tree binding is documented.
>>
>> For testing you should be able to take any hardware which has a PL011
>> and change the DT to use a "arm,sbsa-uart" compatible string.
>> Of course testing with a real SBSA Generic UART is welcomed!
>>
> I have tested this series on Juno where it seems to work and also on FVP
> model where there are some issues.
> 
> On the FVP when we enter usespace a couple of 32 character strings are
> printed then nothing else. 32 Characters is a suspicious number.

Can you try to add:
-C bp.pl011_uart0.untimed_fifos=0
to your model command line? (given that your model supports this option)

We discovered that lately, also not sure how the default for this
setting is handled these days in the various model versions.

We are about to investigate this here atm.
This issue seems to be introduced by Dave's FIFO patch.

Cheers,
Andre.

> This occurs with both OE based FS from linaro and debian ubstable FS.
> 
> My FVP is version 5602
> 
> Graeme
> 
>> Cheers,
>> Andre
>>
>> [1] ARM-DEN-0029 Server Base System Architecture, available (click-
>>     thru...) from http://infocenter.arm.com
>> [2] http://lists.infradead.org/pipermail/linux-arm-kernel/2015-January/315248.html
>> [3] http://www.linux-arm.org/git?p=linux-ap.git
>>     git://linux-arm.org/linux-ap.git
>>
>> Andre Przywara (10):
>>   drivers: PL011: avoid potential unregister_driver call
>>   drivers: PL011: refactor pl011_startup()
>>   drivers: PL011: refactor pl011_shutdown()
>>   drivers: PL011: refactor pl011_set_termios()
>>   drivers: PL011: refactor pl011_probe()
>>   drivers: PL011: replace UART_MIS reading with _RIS & _IMSC
>>   drivers: PL011: move cts_event workaround into separate function
>>   drivers: PL011: allow avoiding UART enabling/disabling
>>   drivers: PL011: allow to supply fixed option string
>>   drivers: PL011: add support for the ARM SBSA generic UART
>>
>>  .../devicetree/bindings/serial/arm_sbsa_uart.txt   |    9 +
>>  drivers/tty/serial/amba-pl011.c                    |  510 ++++++++++++++------
>>  2 files changed, 381 insertions(+), 138 deletions(-)
>>  create mode 100644 Documentation/devicetree/bindings/serial/arm_sbsa_uart.txt
>>
>> -- 
>> 1.7.9.5
>>
>>
>> _______________________________________________
>> linux-arm-kernel mailing list
>> linux-arm-kernel at lists.infradead.org
>> http://lists.infradead.org/mailman/listinfo/linux-arm-kernel
>